#!/bin/tcsh
#
#**********************************************************************
#   Define directories (CAPITAL LETTERS)
#**********************************************************************
#
# HOME is disk
# ATOMIC is atomic data directory. It is defined in 
# aliases_for_cmfgen.sh
#
setenv CMFGEN_PROG   $cmfdist/exe/cmfgen_dev.exe
#setenv NEXT_JOB      ~jdh/next_job3.sh
#
#***********************************************************************
#    Atomic data soft links. All other shell commands should be
#    place after these links. These links are model dependent. Ther
#    are required by CMFGEN, CMF_FLUX, and DISPGEN
#
#    When N_F=N_S, no F_TO_S link is needed.
#***********************************************************************

# ***********************************************************************
# Copy file across with main settings.
# ***********************************************************************

cp -f VADAT_INIT VADAT

#***********************************************************************
#  Generic data
#  ------------

 ln -sf  $ATOMIC/misc/two_phot_data.dat                     TWO_PHOT_DATA
 ln -sf  $ATOMIC/misc/xray_phot_fits.dat                    XRAY_PHOT_FITS
 ln -sf  $ATOMIC/HYD/I/5dec96/hyd_l_data.dat                HYD_L_DATA
 ln -sf  $ATOMIC/HYD/I/5dec96/gbf_n_data.dat                GBF_N_DATA
#
#***********************************************************************
#    Hydrogen
#   ----------

 ln -sf  $ATOMIC/HYD/I/5dec96/hiphot.dat                   PHOTHI_A
 ln -sf  $ATOMIC/HYD/I/5dec96/hi_osc.dat                   HI_F_OSCDAT
 ln -sf  $ATOMIC/HYD/I/5dec96/hi_f_to_s_15.dat             HI_F_TO_S
 ln -sf  $ATOMIC/HYD/I/5dec96/hicol.dat                    HI_COL_DATA

#***********************************************************************
#    He I
#   ----------

 ln -sf  $ATOMIC/HE/I/11may07/heiphot_a4.dat               PHOTHeI_A
 ln -sf  $ATOMIC/HE/I/11may07/heioscdat_a4.dat             HeI_F_OSCDAT
 ln -sf  $ATOMIC/HE/I/11may07/hei_f_to_s_a4.dat            HeI_F_TO_S
 ln -sf  $ATOMIC/HE/I/11may07/heicol.dat                   HeI_COL_DATA

#***********************************************************************
#    He II
#   ----------

 ln -sf  $ATOMIC/HE/II/5dec96/he2phot.dat                  PHOTHe2_A
 ln -sf  $ATOMIC/HE/II/5dec96/he2_osc.dat                  He2_F_OSCDAT
 ln -sf  $ATOMIC/HE/II/5dec96/he2_f_to_s_10.dat            He2_F_TO_S
 ln -sf  $ATOMIC/HE/II/5dec96/he2col.dat                   He2_COL_DATA

#    Fe I
#   ----------

 ln -sf  $ATOMIC/FE/I/29apr04/phot_smooth_3000             PHOTFeI_A
 ln -sf  $ATOMIC/FE/I/29apr04/fei_osc                      FeI_F_OSCDAT
 ln -sf  $ATOMIC/FE/I/29apr04/f_to_s_181                   FeI_F_TO_S
 ln -sf  $ATOMIC/FE/I/29apr04/col_data                     FeI_COL_DATA

#***********************************************************************
#    Fe II
#   ----------

 ln -sf  $ATOMIC/FE/II/24may96/phot_op.dat                 PHOTFe2_A
 ln -sf  $ATOMIC/FE/II/16nov98/osc_nahar_forb.dat          Fe2_F_OSCDAT
 ln -sf  $ATOMIC/FE/II/16nov98/f_to_s.827_to_134           Fe2_F_TO_S
 ln -sf  $ATOMIC/FE/II/16nov98/fe2_col.dat                 Fe2_COL_DATA

#***********************************************************************
#    Co II
#   ----------

 ln -sf  $ATOMIC/COB/II/18oct00/phot_data.dat              PHOTCo2_A
 ln -sf  $ATOMIC/COB/II/18oct00/coii_osc.dat               Co2_F_OSCDAT
 ln -sf  $ATOMIC/COB/II/18oct00/f_to_s_55.dat              Co2_F_TO_S
 ln -sf  $ATOMIC/COB/II/18oct00/col_guess.dat              Co2_COL_DATA

#***********************************************************************
#    Ni II
#   ----------

 ln -sf  $ATOMIC/NICK/II/18oct00/phot_data.dat             PHOTNk2_A
 ln -sf  $ATOMIC/NICK/II/18oct00/nkii_osc.dat              Nk2_F_OSCDAT
 ln -sf  $ATOMIC/NICK/II/18oct00/f_to_s_59.dat             Nk2_F_TO_S
 ln -sf  $ATOMIC/NICK/II/18oct00/col_guess.dat             Nk2_COL_DATA

#*****************************************************************************
#
# END OF ATOMIC DATA SOFT LINKS
#
#*****************************************************************************
 
#If we pass a paremeter to the BATCH file, we assume that we just want to
#ln -sf  data files. In this case we exit.
 
if ( $1 == '') then
 
else
    echo "Data files assigned"
    exit
endif
#
#***********************************************************************
#
#***********************************************************************
#Input files
#
# ln -sf  He2_IN                                        T_IN
 ln -sf  RDINR                                          RDINR
 #ln -sf /home/maer0651/Desktop/modeling/monte-carlo/jekyll/bin/test-evo/SN_HYDRO_DATA-M15-d50 SN_HYDRO_DATA
#
#**********************************************************************
#    Output files
#**********************************************************************
#ln -sf /usr/limey/jdh/BAMAT            BAMAT
#ln -sf /usr/limey/jdh/BAION            BAION
#
#    Run program
#***********************************************************************
#
#Putting time stam etc on program
#
rm -f batch.log
#
echo "Program started on:" > 'batch.log'
date >> 'batch.log'
echo "Machine name is :" >> 'batch.log'
uname -n >> 'batch.log'
#
exec nice -19 $CMFGEN_PROG >>& 'batch.log'
#
echo "Program finished on:" >> 'batch.log'
date >> 'batch.log'
 
#***********************************************************************
# Execute the command in next_job.sh. This will allow another job to
# be started.
#***********************************************************************
 
# $NEXT_JOB &
