#!/usr/bin/python

import sys
from numpy import *
from subprocess import call
import pylab
from sne.util import *
from sne.ph_consts import *

# Check that mandatory arguments are supplied
if len(sys.argv)<5: sys.exit()

model_dir=sys.argv[1]
t_start=float(sys.argv[2])
t_stop=float(sys.argv[3])
r_min_start=float(sys.argv[4])
n_iter=int(sys.argv[5])

n_iter_min=1
arg_value=get_key_value_arg("n_iter_min",sys.argv)
if arg_value!="" : n_iter_min=int(arg_value)

n_sub_iter=1
arg_value=get_key_value_arg("n_sub_iter",sys.argv)
if arg_value!="" : n_sub_iter=int(arg_value)

def update_cmfgen_variables(cmfgen_file,variable) :

    f=open(cmfgen_file,"r")
    line=f.readlines()
    f.close()

    for i in range(0,len(line)) :
        for j in range(0,len(variable)) :
            if line[i][0]!="!" and len(line[i].split())>1 :
                if line[i].split()[1]=="[%s]"%variable[j][0] :
                    line[i]=line[i].replace("\t"," ")
                    line[i]="%s %s"%(variable[j][1],line[i].partition(" ")[2])
                    break;

    f=open(cmfgen_file,"w")
    f.writelines(line)
    f.close()

dlogt=log10(t_stop/t_start)/(n_iter*n_sub_iter)

i=1
t=t_start
r_min=r_min_start

if (n_iter_min==1) :

    # Update VADAT
    update_cmfgen_variables("%s/%d/VADAT_INIT"%(model_dir,i),[["TS_NO","%d"%(i)],["SN_AGE","%E"%(t)],["RSTAR","%E"%(r_min)],["USE_J_REL","T"],["INCL_REL","T"],["INCL_ADV_TRANS","T"],["INCL_DJDT","F"],["USE_DJDT_RTE","F"],["FIX_T","T"],["FIX_T_AUTO","F"],["DO_DDT","F"],["INC_AD","F"],["INC_ADV","F"]])
    #update_cmfgen_variables("%s/%d/VADAT_INIT"%(model_dir,i),[["TS_NO","%d"%(i)],["SN_AGE","%E"%(t)],["RSTAR","%E"%(r_min)],["USE_J_REL","T"],["INCL_REL","T"],["INCL_ADV_TRANS","T"],["INCL_DJDT","F"],["USE_DJDT_RTE","F"],["FIX_T","T"],["FIX_T_AUTO","F"],["DO_DDT","F"],["INC_AD","F"],["INC_ADV","F"]])
    #update_cmfgen_variables("%s/%d/VADAT_INIT"%(model_dir,i),[["TS_NO","%d"%(i)],["SN_AGE","%E"%(t)],["RSTAR","%E"%(r_min)],["USE_J_REL","F"],["INCL_REL","F"],["INCL_ADV_TRANS","F"],["INCL_DJDT","F"],["USE_DJDT_RTE","F"],["FIX_T","T"],["FIX_T_AUTO","F"],["DO_DDT","F"],["INC_AD","F"],["INC_ADV","F"],["USE_FIXED_J","T"]])

    # Update IN_ITS
    update_cmfgen_variables("%s/%d/IN_ITS"%(model_dir,i),[["DO_T_AUTO","F"]])
    #update_cmfgen_variables("%s/%d/IN_ITS"%(model_dir,i),[["DO_T_AUTO","T"]])
    #update_cmfgen_variables("%s/%d/IN_ITS"%(model_dir,i),[["DO_T_AUTO","F"],["DO_LAM_IT","T"],["DO_LAM_AUTO","F"]])

    print "Run initial SN model"

    # Run initial SN model
    call("cd %s/%d; echo $cmfdist; ./batch.sh; cd ../.."%(model_dir,1),shell=True)
    
for i in range(i+1,n_iter+1) :

    for j in range(0,n_sub_iter) :

        # Update t and R_min
        t=t*10**(dlogt)
        r_min=r_min*10**(dlogt)

        if (i>=n_iter_min) :

            if (j==0) : prev_model_dir="%s/%d"%(model_dir,i-1)
            else : prev_model_dir="%s/%d-%d"%(model_dir,i,j-1)

            if (j==(n_sub_iter-1)) : next_model_dir="%s/%d"%(model_dir,i)
            else : next_model_dir="%s/%d-%d"%(model_dir,i,j)

            # Create new SN model directory
            #call("mkdir %s/%d"%(model_dir,i),shell=True)
            call("mkdir %s"%(next_model_dir),shell=True)

            # Copy SN model
            #call("drad_cpmod.sh %s/%d %s/%d"%(model_dir,i-1,model_dir,i,j),shell=True)
            #call("cp %s/%d/VADAT_INIT %s/%d/VADAT_INIT"%(model_dir,i-1,model_dir,i),shell=True)
            call("drad_cpmod.sh %s %s"%(prev_model_dir,next_model_dir),shell=True)
            call("cp %s/VADAT_INIT %s/VADAT_INIT"%(prev_model_dir,next_model_dir),shell=True)
            #call("cp %s/%d/ADJUST_R_DEFAULTS %s/%d/ADJUST_R_DEFAULTS"%(model_dir,i-1,model_dir,i),shell=True)

            # Update VADAT
            #update_cmfgen_variables("%s/%d/VADAT_INIT"%(model_dir,i),[["TS_NO","%d"%(i)],["SN_AGE","%E"%(t)],["RSTAR","%E"%(r_min)],["USE_J_REL","F"],["INCL_REL","F"],["INCL_ADV_TRANS","F"],["INCL_DJDT","T"],["USE_DJDT_RTE","T"],["FIX_T","T"],["FIX_T_AUTO","F"],["DO_DDT","F"],["INC_AD","F"]])
            update_cmfgen_variables("%s/VADAT_INIT"%(next_model_dir),[["TS_NO","%d"%(i)],["SN_AGE","%E"%(t)],["RSTAR","%E"%(r_min)],["USE_J_REL","F"],["INCL_REL","F"],["INCL_ADV_TRANS","F"],["INCL_DJDT","T"],["USE_DJDT_RTE","T"],["FIX_T","T"],["FIX_T_AUTO","F"],["DO_DDT","T"],["INC_AD","T"],["INC_ADV","F"]])

            # Update IN_ITS
            #update_cmfgen_variables("%s/%d/IN_ITS"%(model_dir,i),[["DO_T_AUTO","T"]])
            update_cmfgen_variables("%s/IN_ITS"%(next_model_dir),[["DO_T_AUTO","T"]])

            print "Run SN model %d:%d, t=%.1f days"%(i,j,t)
    
            # Run SN model
            #call("cd %s/%d; ./batch.sh; cd ../.."%(model_dir,i),shell=True)
            call("cd %s/; ./batch.sh; cd ../.."%(next_model_dir),shell=True)

            #if (j==(n_sub_iter-1)) call("rm -rf %d-*"%(i),shell=True)
